设置图案填充的图案名称和图案类型。 支持的平台:仅窗口 签名工 务 局: object.SetPattern PatternType, PatternName
返回值(RetVal)无返回值。 言论填充图案可以通过以下选项之一定义: 预定义:从acad.pat文件中定义的模式名称中选择模式名称。 用户定义:使用当前线型定义线型的线阵列。 自定义:从 acad.pat 文件以外的 PAT 文件中选择模式名称。 注意:该方法应仅用于活动文档。SetPattern
例子工 务 局: Sub Example_SetPattern() ' This example creates an associative hatch in model space. ' The hatch pattern is then changed. Dim hatchObj As AcadHatch Dim patternName As String Dim PatternType As Long Dim bAssociativity As Boolean ' Define the hatch patternName = "ANSI31" PatternType = 0 bAssociativity = True ' Create the associative Hatch object Set hatchObj = ThisDrawing.ModelSpace.AddHatch(PatternType, patternName, bAssociativity) ' Create the outer loop for the hatch. ' An arc and a line are used to create a closed loop. Dim outerLoop(0 To 1) As AcadEntity Dim center(0 To 2) As Double Dim radius As Double Dim startAngle As Double Dim endAngle As Double center(0) = 5: center(1) = 3: center(2) = 0 radius = 3 startAngle = 0 endAngle = 3.141592 Set outerLoop(0) = ThisDrawing.ModelSpace.AddArc(center, radius, startAngle, endAngle) Set outerLoop(1) = ThisDrawing.ModelSpace.AddLine(outerLoop(0).startPoint, outerLoop(0).endPoint) ' Append the outer loop to the hatch object hatchObj.AppendOuterLoop (outerLoop) ' Append the first circle as one inner loop Dim innerLoop1(0) As AcadEntity center(0) = 5: center(1) = 4.5: center(2) = 0 radius = 1 Set innerLoop1(0) = ThisDrawing.ModelSpace.AddCircle(center, radius) hatchObj.AppendInnerLoop (innerLoop1) ' Append the second circle as the other inner loop Dim innerLoop2(0) As AcadEntity radius = 0.5 Set innerLoop2(0) = ThisDrawing.ModelSpace.AddCircle(center, radius) hatchObj.AppendInnerLoop (innerLoop2) ' Evaluate and display the hatch hatchObj.Evaluate ZoomAll ' Find the name of the hatch pattern patternName = hatchObj.patternName MsgBox "The hatch pattern is " & hatchObj.patternName, , "SetPattern Example" ' Change the hatch pattern hatchObj.SetPattern acHatchPatternTypePreDefined, "BRICK" hatchObj.Evaluate ThisDrawing.Regen True MsgBox "The hatch pattern is now " & hatchObj.patternName, , "SetPattern Example" End Sub Visual LISP: (vl-load-com) (defun c:Example_SetPattern() ;; This example creates an associative hatch in model space. ;; The hatch pattern is then changed. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Define the hatch (setq patternName "ANSI31" patternType 0 bAssociativity :vlax-true) ;; Create the associative Hatch object (setq modelSpace (vla-get-ModelSpace doc)) (setq hatchObj (vla-AddHatch modelSpace patternType patternName bAssociativity acHatchObject)) ;; Create the outer loop for the hatch. ;; An arc and a line are used to create a closed loop. (setq center (vlax-3d-point 5 3 0) radius 3 startAngle 0 endAngle 3.141592) (setq arc (vla-AddArc modelSpace center radius startAngle endAngle)) (setq line (vla-AddLine modelSpace (vla-get-StartPoint arc) (vla-get-EndPoint arc))) (setq outerLoop (vlax-make-safearray vlax-vbObject '(0 . 1))) (vlax-safearray-put-element outerLoop 0 arc) (vlax-safearray-put-element outerLoop 1 line) ;; Append the outer loop to the hatch object (vla-AppendOuterLoop hatchObj outerLoop) ;; Append the first circle as one inner loop (setq center (vlax-3d-point 5 4.5 0) radius 1) (setq circle1 (vla-AddCircle modelSpace center radius)) (setq innerLoop1 (vlax-make-safearray vlax-vbObject '(0 . 0))) (vlax-safearray-put-element innerLoop1 0 circle1) (vla-AppendInnerLoop hatchObj innerLoop1) ;; Append the second circle as the other inner loop (setq radius 0.5) (setq innerLoop2 (vlax-make-safearray vlax-vbObject '(0 . 0))) (setq circle2 (vla-AddCircle modelSpace center radius)) (vlax-safearray-put-element innerLoop2 0 circle2) (vla-AppendInnerLoop hatchObj innerLoop2) ;; Evaluate and display the hatch (vla-Evaluate hatchObj) (vla-ZoomAll acadObj) ;; Find the name of the hatch pattern (setq patternName (vla-get-patternName hatchObj)) (alert (strcat "The hatch pattern is " patternName)) ;; Change the hatch pattern (vla-SetPattern hatchObj acHatchPatternTypePreDefined "BRICK") (vla-Evaluate hatchObj) (vla-Regen doc :vlax-true) (alert (strcat "The hatch pattern is now " (vla-get-patternName hatchObj))) ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-8 19:11
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.